<template>
	<div>
		<ValidationProvider
			v-slot="{ errors, ariaMsg, ariaInput }"
			:rules="rules"
			:immediate="false"
			onkeydown="return event.key != 'Enter';"
		>
			<!-- eslint-disable-next-line vuejs-accessibility/label-has-for  -->
			<label
				class="mk-focus-disable inline-flex justify-start items-start"
				@keydown.enter="roleType == 'checkbox' ? $emit('change', checked) : ''"
				@keypress.space="roleType == 'checkbox' ? $emit('change', checked) : ''"
			>
				<input
					:id="id || false"
					v-focus="setFocus"
					:tabindex="tabValue"
					:aria-label="ariaLabel ? ariaLabel : radioTitle"
					:type="checkType"
					:checked="checked"
					:value="checked ? checked : ''"
					:role="roleType"
					:name="name || false"
					:aria-checked="checked"
					v-bind="ariaInput"
					class="ml-0.5 w-6 h-6 text-black rounded-full checked:border-transparent focus:ring-1 focus:ring-black focus:outline-none mk-checkbox cursor-pointer"
					@focus="roleType == 'radio' && !checked ? $emit('change', checked) : ''"
					@change="$emit('change', checked)"
					@click="$emit('clicked', $event)"
					@keypress.space="roleType == 'checkbox' ? $emit('change', checked) : ''"
				/>
				<span :class="['ml-4', titleClass]" aria-hidden="true" v-html="radioTitle">{{ radioTitle }}</span>
				<p v-if="radioDescription" v-html="radioDescription">
					{{ radioDescription }}
				</p>
			</label>
			<p v-show="errors" class="text-error-20 text-sm pl-11" v-bind="ariaMsg">
				{{ errors[0] }}
			</p>
		</ValidationProvider>
	</div>
</template>
<script>
import { ValidationProvider } from 'vee-validate';
export default {
	name: 'MkCheck',
	components: {
		ValidationProvider,
	},
	props: {
		setFocus: {
			type: String,
			default: 'false',
		},
		radioTitle: {
			type: String,
			default: '',
		},
		radioDescription: {
			type: String,
			default: '',
		},
		checked: {
			type: Boolean,
			default: false,
		},
		id: {
			type: String,
			default: '',
		},
		name: {
			type: String,
			default: '',
		},
		titleClass: {
			type: String,
			default: 'font-primary-font-light text-base',
		},
		rules: {
			type: String,
			default: '',
		},
		ariaLabel: {
			type: String,
			default: '',
		},
		roleType: {
			type: String,
			default: 'checkbox',
		},
		checkType: {
			type: String,
			default: 'checkbox',
		},
		tabValue: {
			type: Number,
			default: 0,
		},
	},
};
</script>
